// generated from rosidl_generator_c/resource/idl__struct.h.em
// with input from hri_msgs:msg/AudioFeatures.idl
// generated code does not contain a copyright notice

#ifndef HRI_MSGS__MSG__DETAIL__AUDIO_FEATURES__STRUCT_H_
#define HRI_MSGS__MSG__DETAIL__AUDIO_FEATURES__STRUCT_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stddef.h>
#include <stdint.h>


// Constants defined in the message

// Include directives for member types
// Member 'mfcc'
#include "rosidl_runtime_c/primitives_sequence.h"

/// Struct defined in msg/AudioFeatures in the package hri_msgs.
/**
  * This message encodes the 16 audio features selected
  * in the INTERSPEECH2009 challenge.
  *
  * Reference: Schuller, Steidl, Batliner, The INTERSPEECH 2009 Emotion Challenge
  *
  * They can be extract using the OpenSMILE toolkit with the present
  * IS09_emotion.conf
 */
typedef struct hri_msgs__msg__AudioFeatures
{
  /// zero-crossing rate from the time signal
  float zcr;
  /// root mean square frame energy
  float rms;
  /// pitch frequency (normalised to 500 Hz)
  float pitch;
  /// harmonics-to-noise ratio by autocorrelation function
  float hnr;
  /// mel-frequency cepstral coefficients 1 to 12
  rosidl_runtime_c__float__Sequence mfcc;
} hri_msgs__msg__AudioFeatures;

// Struct for a sequence of hri_msgs__msg__AudioFeatures.
typedef struct hri_msgs__msg__AudioFeatures__Sequence
{
  hri_msgs__msg__AudioFeatures * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} hri_msgs__msg__AudioFeatures__Sequence;

#ifdef __cplusplus
}
#endif

#endif  // HRI_MSGS__MSG__DETAIL__AUDIO_FEATURES__STRUCT_H_
