// generated from rosidl_generator_c/resource/idl__struct.h.em
// with input from hri_msgs:msg/Expression.idl
// generated code does not contain a copyright notice

#ifndef HRI_MSGS__MSG__DETAIL__EXPRESSION__STRUCT_H_
#define HRI_MSGS__MSG__DETAIL__EXPRESSION__STRUCT_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stddef.h>
#include <stdint.h>


// Constants defined in the message

/// Constant 'NEUTRAL'.
/**
  * the list of expressions is based on Chambers MSc thesis, Bristol Robotics Lab 2020, and includes the six basic emotions in Eckman's model.
  *
  * Note that a node making use of this message definition is not supposed or
  * expected to handle all listed expressions.
  *
  * This list might change based on future needs/requests.
 */
static const char * const hri_msgs__msg__Expression__NEUTRAL = "neutral";

/// Constant 'ANGRY'.
static const char * const hri_msgs__msg__Expression__ANGRY = "angry";

/// Constant 'SAD'.
static const char * const hri_msgs__msg__Expression__SAD = "sad";

/// Constant 'HAPPY'.
static const char * const hri_msgs__msg__Expression__HAPPY = "happy";

/// Constant 'SURPRISED'.
static const char * const hri_msgs__msg__Expression__SURPRISED = "surprised";

/// Constant 'DISGUSTED'.
static const char * const hri_msgs__msg__Expression__DISGUSTED = "disgusted";

/// Constant 'SCARED'.
static const char * const hri_msgs__msg__Expression__SCARED = "scared";

/// Constant 'PLEADING'.
static const char * const hri_msgs__msg__Expression__PLEADING = "pleading";

/// Constant 'VULNERABLE'.
static const char * const hri_msgs__msg__Expression__VULNERABLE = "vulnerable";

/// Constant 'DESPAIRED'.
static const char * const hri_msgs__msg__Expression__DESPAIRED = "despaired";

/// Constant 'GUILTY'.
static const char * const hri_msgs__msg__Expression__GUILTY = "guilty";

/// Constant 'DISAPPOINTED'.
static const char * const hri_msgs__msg__Expression__DISAPPOINTED = "disappointed";

/// Constant 'EMBARRASSED'.
static const char * const hri_msgs__msg__Expression__EMBARRASSED = "embarrassed";

/// Constant 'HORRIFIED'.
static const char * const hri_msgs__msg__Expression__HORRIFIED = "horrified";

/// Constant 'SKEPTICAL'.
static const char * const hri_msgs__msg__Expression__SKEPTICAL = "skeptical";

/// Constant 'ANNOYED'.
static const char * const hri_msgs__msg__Expression__ANNOYED = "annoyed";

/// Constant 'FURIOUS'.
static const char * const hri_msgs__msg__Expression__FURIOUS = "furious";

/// Constant 'SUSPICIOUS'.
static const char * const hri_msgs__msg__Expression__SUSPICIOUS = "suspicious";

/// Constant 'REJECTED'.
static const char * const hri_msgs__msg__Expression__REJECTED = "rejected";

/// Constant 'BORED'.
static const char * const hri_msgs__msg__Expression__BORED = "bored";

/// Constant 'TIRED'.
static const char * const hri_msgs__msg__Expression__TIRED = "tired";

/// Constant 'ASLEEP'.
static const char * const hri_msgs__msg__Expression__ASLEEP = "asleep";

/// Constant 'CONFUSED'.
static const char * const hri_msgs__msg__Expression__CONFUSED = "confused";

/// Constant 'AMAZED'.
static const char * const hri_msgs__msg__Expression__AMAZED = "amazed";

/// Constant 'EXCITED'.
static const char * const hri_msgs__msg__Expression__EXCITED = "excited";

// Include directives for member types
// Member 'header'
#include "std_msgs/msg/detail/header__struct.h"
// Member 'expression'
#include "rosidl_runtime_c/string.h"

/// Struct defined in msg/Expression in the package hri_msgs.
/**
  * Represents a human facial expression, either in a categorical way, or
  * using the valence/arousal model of emotions
 */
typedef struct hri_msgs__msg__Expression
{
  std_msgs__msg__Header header;
  /// one of the listed expressions
  rosidl_runtime_c__String expression;
  /// Valence/Arousal model of emotions
  /// from -1.0 to +1.0
  float valence;
  /// from -1.0 to +1.0
  float arousal;
  /// from 0.0 to 1.0
  float confidence;
} hri_msgs__msg__Expression;

// Struct for a sequence of hri_msgs__msg__Expression.
typedef struct hri_msgs__msg__Expression__Sequence
{
  hri_msgs__msg__Expression * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} hri_msgs__msg__Expression__Sequence;

#ifdef __cplusplus
}
#endif

#endif  // HRI_MSGS__MSG__DETAIL__EXPRESSION__STRUCT_H_
