// generated from rosidl_generator_c/resource/idl__struct.h.em
// with input from hri_msgs:msg/IdsMatch.idl
// generated code does not contain a copyright notice

#ifndef HRI_MSGS__MSG__DETAIL__IDS_MATCH__STRUCT_H_
#define HRI_MSGS__MSG__DETAIL__IDS_MATCH__STRUCT_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stddef.h>
#include <stdint.h>


// Constants defined in the message

/// Constant 'UNSET'.
enum
{
  hri_msgs__msg__IdsMatch__UNSET = 0
};

/// Constant 'PERSON'.
enum
{
  hri_msgs__msg__IdsMatch__PERSON = 1
};

/// Constant 'FACE'.
enum
{
  hri_msgs__msg__IdsMatch__FACE = 2
};

/// Constant 'BODY'.
enum
{
  hri_msgs__msg__IdsMatch__BODY = 3
};

/// Constant 'VOICE'.
enum
{
  hri_msgs__msg__IdsMatch__VOICE = 4
};

// Include directives for member types
// Member 'id1'
// Member 'id2'
#include "rosidl_runtime_c/string.h"

/// Struct defined in msg/IdsMatch in the package hri_msgs.
/**
  * This message encodes possible matches between transient IDs (face, body,
  * voice) and permanent IDs (person), with their corresponding confidence level.
  * Such messages should be published on the /humans/candidate_matches topic.
  *
  * confidence == 0.0 has the special meaning of: those two IDs are *not* associated.
  * This can be use for instance if one of the ID (eg, a face id) is not valid anymore
  * (face not tracked anymore)
  *
  * Note that setting only one of `id1` or `id2` is invalid. Likewise, `id1` and
  * `id2` can not be equal.
  *
  * ## Examples
  *
  * For instance, a face recognition module might publish the following message
  * to indicate that face 'a3eb4' has been recognised with 63% confidence as
  * person 'b31ad':
  *
  * {id1: 'a3eb4', id1_type: FACE, id2: 'b31ad', id2_type: PERSON, confidence:
  * 0.63, }
  *
  * Another example: a module that detect both faces and skeleton might publish a
  * 100% confidence match between the two:
  *
  * {id1: 'ff424', id1_type: FACE, id2: '850d1', id2_type: BODY, confidence:
  * 1.0, }
 */
typedef struct hri_msgs__msg__IdsMatch
{
  rosidl_runtime_c__String id1;
  int8_t id1_type;
  rosidl_runtime_c__String id2;
  int8_t id2_type;
  float confidence;
} hri_msgs__msg__IdsMatch;

// Struct for a sequence of hri_msgs__msg__IdsMatch.
typedef struct hri_msgs__msg__IdsMatch__Sequence
{
  hri_msgs__msg__IdsMatch * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} hri_msgs__msg__IdsMatch__Sequence;

#ifdef __cplusplus
}
#endif

#endif  // HRI_MSGS__MSG__DETAIL__IDS_MATCH__STRUCT_H_
