// generated from rosidl_generator_c/resource/idl__struct.h.em
// with input from hri_msgs:msg/Skeleton2D.idl
// generated code does not contain a copyright notice

#ifndef HRI_MSGS__MSG__DETAIL__SKELETON2_D__STRUCT_H_
#define HRI_MSGS__MSG__DETAIL__SKELETON2_D__STRUCT_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stddef.h>
#include <stdint.h>


// Constants defined in the message

/// Constant 'NOSE'.
/**
  * skeletal key points codes
  * Follows OpenPose coco model convention
  * https://github.com/CMU-Perceptual-Computing-Lab/openpose/blob/master/doc/output.md#pose-output-format-coco
 */
enum
{
  hri_msgs__msg__Skeleton2D__NOSE = 0
};

/// Constant 'NECK'.
enum
{
  hri_msgs__msg__Skeleton2D__NECK = 1
};

/// Constant 'RIGHT_SHOULDER'.
enum
{
  hri_msgs__msg__Skeleton2D__RIGHT_SHOULDER = 2
};

/// Constant 'RIGHT_ELBOW'.
enum
{
  hri_msgs__msg__Skeleton2D__RIGHT_ELBOW = 3
};

/// Constant 'RIGHT_WRIST'.
enum
{
  hri_msgs__msg__Skeleton2D__RIGHT_WRIST = 4
};

/// Constant 'LEFT_SHOULDER'.
enum
{
  hri_msgs__msg__Skeleton2D__LEFT_SHOULDER = 5
};

/// Constant 'LEFT_ELBOW'.
enum
{
  hri_msgs__msg__Skeleton2D__LEFT_ELBOW = 6
};

/// Constant 'LEFT_WRIST'.
enum
{
  hri_msgs__msg__Skeleton2D__LEFT_WRIST = 7
};

/// Constant 'RIGHT_HIP'.
enum
{
  hri_msgs__msg__Skeleton2D__RIGHT_HIP = 8
};

/// Constant 'RIGHT_KNEE'.
enum
{
  hri_msgs__msg__Skeleton2D__RIGHT_KNEE = 9
};

/// Constant 'RIGHT_ANKLE'.
enum
{
  hri_msgs__msg__Skeleton2D__RIGHT_ANKLE = 10
};

/// Constant 'LEFT_HIP'.
enum
{
  hri_msgs__msg__Skeleton2D__LEFT_HIP = 11
};

/// Constant 'LEFT_KNEE'.
enum
{
  hri_msgs__msg__Skeleton2D__LEFT_KNEE = 12
};

/// Constant 'LEFT_ANKLE'.
enum
{
  hri_msgs__msg__Skeleton2D__LEFT_ANKLE = 13
};

/// Constant 'LEFT_EYE'.
enum
{
  hri_msgs__msg__Skeleton2D__LEFT_EYE = 14
};

/// Constant 'RIGHT_EYE'.
enum
{
  hri_msgs__msg__Skeleton2D__RIGHT_EYE = 15
};

/// Constant 'LEFT_EAR'.
enum
{
  hri_msgs__msg__Skeleton2D__LEFT_EAR = 16
};

/// Constant 'RIGHT_EAR'.
enum
{
  hri_msgs__msg__Skeleton2D__RIGHT_EAR = 17
};

// Include directives for member types
// Member 'header'
#include "std_msgs/msg/detail/header__struct.h"
// Member 'skeleton'
#include "hri_msgs/msg/detail/normalized_point_of_interest2_d__struct.h"

/// Struct defined in msg/Skeleton2D in the package hri_msgs.
/**
  * This message contains a list of skeletal keypoints 
  * (0, 0) is at top-left corner of image
 */
typedef struct hri_msgs__msg__Skeleton2D
{
  /// Header timestamp should be acquisition time of the original image
  std_msgs__msg__Header header;
  /// array of 18 skeletal key points coordinates, one per skeletal key point, ordered per skeletal key points codes
  hri_msgs__msg__NormalizedPointOfInterest2D skeleton[18];
} hri_msgs__msg__Skeleton2D;

// Struct for a sequence of hri_msgs__msg__Skeleton2D.
typedef struct hri_msgs__msg__Skeleton2D__Sequence
{
  hri_msgs__msg__Skeleton2D * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} hri_msgs__msg__Skeleton2D__Sequence;

#ifdef __cplusplus
}
#endif

#endif  // HRI_MSGS__MSG__DETAIL__SKELETON2_D__STRUCT_H_
